//xsetaseta@gmail.com
//Lector de sensor de temperatura externa 
//Modelo oh!haus
//25/11/2022

#define DEBUG
//#define VERDATA
//#define VERLOGI

#define BIT_INICIO 73
#define BIT1 35
#define BIT0 19

#define BIT1a  BIT1-1
#define BIT1b  BIT1+1
#define BIT0a  BIT0-1
#define BIT0b  BIT0+1
#define BIT_INICIOa BIT_INICIO-2
#define BIT_INICIOb BIT_INICIO+2

#define NUMBIT 36
#define IDATA1  3
#define IDATA2  5
#define IDATA3  11
#define IDATA4  22

#define IN_READ 2

int canal;
int grados;
int humedad;

unsigned long time,timeU,timeM,diferencia;
int Adiferencia;
bool estadoDato;
unsigned  NumBit;
char datos[50];

int z;
bool ledState;

void setup() 
{
  Serial.begin(9600);
  Serial.println("Int433_oh!haus");
  pinMode(IN_READ, INPUT);
  attachInterrupt(digitalPinToInterrupt(IN_READ), InumPasos, RISING);
  pinMode(13,OUTPUT);
}

void loop() 
{
  if(estadoDato==1)
   {     
     estadoDato=0;
     if(Adiferencia>15 && Adiferencia<100)
       { 
        //Serial.println(Adiferencia,DEC);

        if(Adiferencia>=BIT0a && Adiferencia<=BIT0b)
          { 
            #ifdef VERDATA           
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("0");
            #endif
            datos[NumBit]=0;
            if(NumBit<40) NumBit++;
            goto saltox;
          }
          
        if(Adiferencia>BIT1a && Adiferencia<BIT1b)
          { 
            #ifdef VERDATA         
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("1");
            #endif
            datos[NumBit]=1;
            if(NumBit<40) NumBit++;  
            goto saltox;
          } 
          
        if(Adiferencia>BIT_INICIOa && Adiferencia<BIT_INICIOb)
            { 
              #ifdef VERLOGI
                Serial.print("####"); Serial.println(NumBit,DEC); 
              #endif
              #ifdef VERDATA                  
                Serial.println(Adiferencia,DEC);
              #endif
              
              if(NumBit==NUMBIT) {   getDatos();    }
              NumBit=0;
              goto saltox;
            }
        
       }
       
   }
saltox:       


   time=millis();
   z=time-timeM;
   if(z>1000 )
    {
      if (ledState == LOW) { ledState = HIGH; } else { ledState = LOW;  }
      digitalWrite(13, ledState);
      timeM=time;
    }
      
      
}



void getDatos(void)
{
  int z;
           #ifdef VERLOGI
                    for(z=0;z<=NUMBIT;z++) 
                      {
                        Serial.print(datos[z],DEC);
                        if(z==IDATA1 || z==IDATA2 || z==IDATA3 || z==IDATA4) Serial.print(" ");
                      } 
                    Serial.println("<-");
           #endif       
                     grados=0;
                     for(z=IDATA4+1;z>IDATA3;z--)
                      {
                        grados<<=1;
                        if(datos[z]==1)grados|=1;
                      }
                      
                     humedad=0;
                     for(z=IDATA3;z>IDATA2;z--)
                      {
                        humedad<<=1;
                        if(datos[z]==1)humedad|=1;
                      }
                     canal=0;
                     for(z=IDATA1+1;z<=IDATA2;z++)
                      {
                        canal<<=1;
                        if(datos[z]==1)canal|=1;
                      }
                 #ifdef VERLOGI
                     Serial.print(grados,BIN);  Serial.print(" "); Serial.print(humedad,BIN);               
                 #endif
                     Serial.println("INICIO");
                     Serial.print("Grados="); Serial.println(grados,DEC);
                     Serial.print("Humedad="); Serial.println(humedad,DEC);
                     Serial.print("Canal="); Serial.println(canal,DEC);
                     Serial.println("FINAL\n");
}


void InumPasos()
{
  time=micros();         
  diferencia=time-timeU;
  Adiferencia=diferencia>>7;
  estadoDato=1; 
salto: 
  timeU=time; 
}
