//xsetaseta@gmail.com
//Lector de sensor de temperatura externa Modelo 40170
//25/11/2022
// arduino 1.8.13

#define DEBUG
//#define VERDATA   //Ver valores
//#define VERLOGI   //Ver binarios
//#define VERTEST   //Ver valores de ajuste

#define BIT_INICIO 78
#define BIT1 39
#define BIT0 19

#define BIT1a  BIT1-1
#define BIT1b  BIT1+1
#define BIT0a  BIT0-1
#define BIT0b  BIT0+1
#define BIT_INICIOa BIT_INICIO-2
#define BIT_INICIOb BIT_INICIO+2

#define NUMBIT 28
#define IDATA1  6
#define IDATA2  11
#define IDATA3  23
#define IDATA4  25

#define IN_READ 2

int canal;
int grados;
int humedad;
int bateria,byte1,byte2;

unsigned long time,timeU,timeM,diferencia;
int Adiferencia;
bool estadoDato;
unsigned  NumBit;
char datos[50];

int z;
bool ledState;


//---Interrupcion--------------
void InumPasos()
{
  time=micros();         
  diferencia=time-timeU;
  Adiferencia=diferencia>>7;
  estadoDato=1; 
salto: 
  timeU=time; 
}
//-----------------------------

void setup() 
{
  Serial.begin(9600);
  Serial.println("Int433_Mode40170");
  pinMode(IN_READ, INPUT);
  attachInterrupt(digitalPinToInterrupt(IN_READ), InumPasos, RISING);
  pinMode(13,OUTPUT);
}

void loop() 
{
  if(estadoDato==1)
   {     
     estadoDato=0;
     if(Adiferencia>15 && Adiferencia<100)
       { 
        #ifdef VERTEST
          Serial.println(Adiferencia,DEC);
        #else
        if(Adiferencia>=BIT0a && Adiferencia<=BIT0b)
          { 
            #ifdef VERDATA           
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("0");
            #endif
            datos[NumBit]=0;
            if(NumBit<40) NumBit++;
            goto saltox;
          }
          
        if(Adiferencia>BIT1a && Adiferencia<BIT1b)
          { 
            #ifdef VERDATA         
              Serial.print(Adiferencia,DEC);
            #endif
            #ifdef VERLOGI
              Serial.print("1");
            #endif
            datos[NumBit]=1;
            if(NumBit<40) NumBit++;  
            goto saltox;
          } 
          
        if(Adiferencia>BIT_INICIOa && Adiferencia<BIT_INICIOb)
            { 
              #ifdef VERLOGI
                Serial.print("####"); Serial.println(NumBit,DEC); 
              #endif
              #ifdef VERDATA                  
                Serial.println(Adiferencia,DEC);
              #endif
              
              if(NumBit==NUMBIT) {   getDatos();    }
              NumBit=0;
              goto saltox;
            }
        #endif
       }
       
   }
saltox:       

//-------Parpadeo------
   time=millis();
   z=time-timeM;
   if(z>1000)
    {
      if (ledState == LOW) { ledState = HIGH; } else { ledState = LOW;  }
      digitalWrite(13, ledState);
      timeM=time;
    }
//---------------------      
      
}



void getDatos(void)
{
  int z;
           #ifdef VERLOGI
                    for(z=0;z<NUMBIT;z++) 
                      {
                        Serial.print(datos[z],DEC);
                        if(z==IDATA1 || z==IDATA2 || z==IDATA3 || z==IDATA4) Serial.print(" ");
                      } 
                    Serial.println("<-");
           #endif       
                     grados=0;
                     for(z=12;z<24;z++)
                      {
                        grados<<=1;
                        if(datos[z]==1)grados|=1;
                      }                     
                     canal=0;
                     for(z=24;z<26;z++)
                      {
                        canal<<=1;
                        if(datos[z]==1)canal|=1;
                      }
                     bateria=0;
                     for(z=7;z<12;z++)
                      {
                        bateria<<=1;
                        if(datos[z]==1)bateria|=1;
                      }

                     byte1=0;
                     for(z=0;z<=6;z++)
                      {
                        byte1<<=1;
                        if(datos[z]==1)byte1|=1;
                      }
                     byte2=0;
                     for(z=26;z<=27;z++)
                      {
                        byte2<<=1;
                        if(datos[z]==1)byte2|=1;
                      }
                    
                 #ifdef VERLOGI
                     Serial.print(grados,BIN);  Serial.print(" ");
                     Serial.print(canal,BIN);  Serial.print(" "); 
                     Serial.print(bateria,BIN);  Serial.print(" "); 
                     Serial.print(byte1,BIN);Serial.print(" "); 
                     Serial.println(byte2,BIN);             
                 #endif
                     Serial.println("INICIO");
                     // Grados negativos
                     if( (grados&2048)==2048)
                      {                       
                        grados=grados-4096;
                      }
                     Serial.print("Grados="); Serial.println(grados,DEC);
                     Serial.print("Canal="); Serial.println(canal,DEC);
                     Serial.print("Bateria="); Serial.println(bateria,DEC);
                     Serial.print("byte1="); Serial.println(byte1,DEC);
                     Serial.print("byte2="); Serial.println(byte2,DEC);
                     Serial.println("FINAL\n");
}
