
//xsetaseta@gmail.com
//Lector de sensor de temperatura externa 
//Modelo oh!haus
//25/11/2022

#define DEBUG

#define BIT_INICIO 73
#define BIT1 35
#define BIT0 19

#define BIT1a  BIT1-1
#define BIT1b  BIT1+1
#define BIT0a  BIT0-1
#define BIT0b  BIT0+1
#define BIT_INICIOa BIT_INICIO-2
#define BIT_INICIOb BIT_INICIO+2

#define IDATA1  3
#define IDATA2  5
#define IDATA3  11
#define IDATA4  22


#include <avr/io.h>
#include <avr/interrupt.h>

#define IN_READ 2

unsigned long time,timeU,timeM,diferencia;


int canal;
int grados;
int humedad;
int control;

unsigned long DatoSalida;
bool estadoDato;


char NumBit;
char datos[100];

unsigned char Adiferencia;
int z;
bool ledState;
int contador;


void setup(void)
{
  Serial.begin(9600);
  Serial.println("Int433_oh!haus");
  pinMode(IN_READ, INPUT);
  pinMode(13,OUTPUT);
  cli();                // Disable INT
  EIMSK |= (1 << INT0);  // Enable external interrupt INT0
  EICRA |= (1 << ISC01); // Trigger INT0 on Change  en bajada
  sei();
}


void loop(void)
{

  if(estadoDato==1)
   {     
     estadoDato=0;
         
     if(Adiferencia>8 && Adiferencia<100)
       { 
        //Serial.print(Adiferencia);
        
        if(Adiferencia>=BIT0a && Adiferencia<=BIT0b)
          {            
            datos[NumBit]=0;
            NumBit++; if(NumBit>98) NumBit=98;
            goto saltox;
          }
          
        if(Adiferencia>BIT1a && Adiferencia<BIT1b)
          {          
            datos[NumBit]=1;
            NumBit++; if(NumBit>98) NumBit=98;     
            goto saltox;
          } 
          
        if(Adiferencia>BIT_INICIOa && Adiferencia<BIT_INICIOb)
            {                    
              if(NumBit>33)
                   {
                     for(z=0;z<=36;z++) 
                      {
                        Serial.print(datos[z],DEC);
                        if(z==IDATA1 || z==IDATA2 || z==IDATA3 || z==IDATA4) Serial.print(" ");
                      } 
                    Serial.print("####");Serial.println(NumBit,DEC); 
                    getDatos();
                    contador=0;   
                   }               
            }
            else
            {
             #ifdef DEBUG
              if(NumBit>4)
               {
                for(z=0;z<=6;z++) 
                      {
                        Serial.print(datos[z],DEC);
                        if(z==IDATA1 || z==IDATA2 || z==IDATA3 || z==IDATA4) Serial.print(" ");
                      } 
                    Serial.print("#**#");Serial.println(NumBit,DEC); 
               }
             #endif
            }
            
         NumBit=0;        
       }

saltox:       
     ;        
   }

   time=millis();
   z=time-timeM;
   if(z>1000 )
    {
      if (ledState == LOW) { ledState = HIGH; } else { ledState = LOW;  }
      digitalWrite(13, ledState);
      Serial.println(contador);
      contador++;
      timeM=time;
    }
}

void getDatos(void)
{
                     grados=0;
                     for(z=23;z>11;z--)
                      {
                        grados<<=1;
                        if(datos[z]==1)grados|=1;
                      }
                      
                     humedad=0;
                     for(z=11;z>5;z--)
                      {
                        humedad<<=1;
                        if(datos[z]==1)humedad|=1;
                      }
                     canal=0;
                     for(z=4;z<6;z++)
                      {
                        canal<<=1;
                        if(datos[z]==1)canal|=1;
                      }
                     Serial.print(grados,BIN);  Serial.print(" "); Serial.print(humedad,BIN);               
                      
                     Serial.print(" G="); Serial.print(grados,DEC);
                     Serial.print(" H="); Serial.print(humedad,DEC);
                     Serial.print(" canal="); Serial.println(canal,DEC);
}



ISR(INT0_vect)
{
  time=micros();         
  diferencia=time-timeU;
  Adiferencia=diferencia>>7;
  estadoDato=1; 
salto: 
  timeU=time; 
}
